      subroutine binout (n1, n2, amount)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  binout   Updated     1994 July 5 16:20.
c               binout   Originated  1994 June 21 10:40.30.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the types, probabilities and values of the random
c               variable of probability bins n1 through n2.
c
c     Logic:    Entry points:  binout.
c binout        Called by:  bin, binfind, binstore, copy, delete, pdfout,
c               renamea, renamex, search.
c               Calls:  (none).
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*8 amount

c.... Initialize.

      nn1 = n1
      nn2 = n2
      if (nn1 .lt. 1) nn1 = 1
      if (nn2 .gt. nbins) nn2 = nbins


      do 150 n = nn1, nn2
        if (abin(n) .eq. ' ') go to 150

 8100   format ('bin  ',a,2x,a)

        if (atypeb(n) .eq. 'discrete event') then

 8105     format ('bin  ',a,2x,a / 'Total probability ',1pe20.12 )
 8110     format ('Total probability ',1pe20.12 )

          write (   6, 8105) abin(n), atypeb(n), prbin(n)
          write (iout, 8105) abin(n), atypeb(n), prbin(n)

        elseif (atypeb(n) .eq. 'discrete value') then

 8120     format ('  Total prob, vran',1p2e20.12 )

          write (   6, 8100) abin(n), atypeb(n)
          write (iout, 8100) abin(n), atypeb(n)
          write (   6, 8120) prbin(n), vranl(n)
          write (iout, 8120) prbin(n), vranl(n)

        elseif (atypeb(n) .eq. 'rel Maxwellian') then

 8130     format ('  vranl,dval,vranr',1p3e20.12 )

          dval = vranr(n) - vranl(n)

          write (   6, 8100) abin(n), atypeb(n)
          write (iout, 8100) abin(n), atypeb(n)
          write (   6, 8110) prbin(n)
          write (iout, 8110) prbin(n)
          write (   6, 8130) vranl(n), dval, vranr(n)
          write (iout, 8130) vranl(n), dval, vranr(n)

        else                  ! Uniform, linear, exp, pow, normal, Planck, Wien.

 8140     format ('  Diff. prob      ',1pe20.12,20x,1pe20.12 /
     &            '  vranl,dval,vranr',1p3e20.12 )
 8150     format ('  Expected value  ',1pe20.12 )

          dval = vranr(n) - vranl(n)

          write (   6, 8100) abin(n), atypeb(n)
          write (iout, 8100) abin(n), atypeb(n)
          write (   6, 8110) prbin(n)
          write (iout, 8110) prbin(n)
          write (   6, 8140) probl(n), probr(n),
     &      vranl(n), dval, vranr(n)
          write (iout, 8140) probl(n), probr(n),
     &      vranl(n), dval, vranr(n)
          write (   6, 8150) vexbin(n)
          write (iout, 8150) vexbin(n)

        endif

        if (atypeb(n) .eq. 'linear') then

 8160     format ('  Slope           ',1pe20.12 )

          write (   6, 8160) conbin(n)
          write (iout, 8160) conbin(n)

        elseif (atypeb(n) .eq. 'exponential') then

 8170     format ('  Decay constant  ',1pe20.12 )

          write (   6, 8170) conbin(n)
          write (iout, 8170) conbin(n)

        elseif (atypeb(n) .eq. 'power-law') then

 8180     format ('  Power           ',1pe20.12 )

          write (   6, 8180) conbin(n)
          write (iout, 8180) conbin(n)

        elseif (atypeb(n) .eq. 'normal') then

 8190     format ('  Std Dev         ',1pe20.12 )

          write (   6, 8190) cosbin(n)
          write (iout, 8190) cosbin(n)

        elseif (atypeb(n) .eq. 'rel Maxwellian') then

 8200     format ('  R = kT/E(rest)  ',1pe20.12 )
 8210     format ('  For R << 1, <beta>  = 1.60 * sqrt(R),',
     &      ' <beta**2>  = 3.00 * R.' /
     &            '  For R = .1, <beta>  = 1.47 * sqrt(R),',
     &      ' <beta**2>  = 2.40 * R.' /
     &            '  For R =  1, <beta>  = 0.9056,        ',
     &      ' <beta**2>  = 0.8315,' /
     &            '              <gamma> = 3.369,         ',
     &      ' <gamma**2> = 14.11.' /
     &            '  For R >> 1, <beta> = 1 - 0.23 / R**2 ',
     &      ' <beta**2>  = 1 - 0.46 / R**2,' /
     &            '              <gamma> = 3.00 * R,      ',
     &      ' <gamma**2> = 12.0 * R**2,' /
     &            '  where gamma = 1 / sqrt( 1 - beta**2).' )

          write (   6, 8200) conbin(n)
          write (iout, 8200) conbin(n)
          write (   6, 8210)
          write (iout, 8210)

        elseif ((atypeb(n) .eq. 'Planck') .or.
     &          (atypeb(n) .eq. 'Wien'))  then

 8220     format ('  Black body temp ',1pe20.12 )

          write (   6, 8220) conbin(n)
          write (iout, 8220) conbin(n)

        endif

        if ((amount .eq. 'max')      .or.
     &      (amount .eq. 'maximum')) then

 8230     format ('    WARNING:  in pdf ',a)

          do 210 nx = 1, npdfxs
            if (abinx(nx) .eq. abin(n)) then
              write (   6, 8230) apdfx(nx)
              write (iout, 8230) apdfx(nx)
            endif
  210     continue

        endif

  150 continue

  999 return

c.... End of subroutine binout.       (+1 line)
      end
