      subroutine bisectx

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  bisectx  Updated     1995 March 6 15:40.
c               bisectx  Originated  1995 March 6 15:40.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To bisect the angle formed by three points.
c
c     Logic:    Entry points:  bisectx.
c bisectx       Called by:  helpall, main.
c
c bisectx       Calls:  aptbang, aptvpln, aptvunb, ptfind.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Input line:  bisect [help]

 8110 format (
     &  '  Command "bisect":  acceptable input lines include:' /
     &  '  "bisect [help]"  Display this message.' /
     &  '  "bisect PNAME1 PNAME2 PNAME3"' /
     &  '     Bisect the angle formed by the 3 points PNAME1,',
     &  ' PNAME2 and PNAME3,' /
     &  '     and display the intercept on the line from PNAME3 to',
     &  ' PNAME1,' /
     &  '     and the vector from PNAME1 to the intercept.' )

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
        go to 999
      endif

c===============================================================================

c.... Input line:  bisect PNAME1 PNAME2 PNAME3

 8135 format ('  bisect ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of words on "bisect" line not 4:  ',i3)

      if (nword .ne. 4) then
        write (   6, 8135) ainput, ninput, nword
        write (iout, 8135) ainput, ninput, nword
        go to 999
      endif

c.... Find the three points defining the angle to be bisected.

      call ptfind (2, n1)
      call ptfind (3, n2)
      call ptfind (4, n3)

      if ((n1 .eq. 0)  .or.
     &    (n2 .eq. 0)  .or.
     &    (n3 .eq. 0)) then
        go to 999
      endif

c.... See if the points are unique.

 8190 format ('  bisect ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Points are not unique:  ' / a / a / a)

      if ((n1 .eq. n2)  .or.
     &    (n2 .eq. n3)  .or.
     &    (n3 .eq. n1)) then
        write (   6, 8190) ainput, ninput, aword(2), aword(3), aword(4)
        write (iout, 8190) ainput, ninput, aword(2), aword(3), aword(4)
        go to 999
      endif

c.... See if the points are coincident or colinear.

c....   Find the normal vector.

        call aptvpln (x(n1), y(n1), z(n1), x(n2), y(n2), z(n2),
     &                x(n3), y(n3), z(n3), 1, tol,
     &                du, dv, dw, vlength, nerra)

 8200 format ('  bisect ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Points are coincident or colinear:  ' / a / a / a)

      if (vlength .eq. 0.0) then
        write (   6, 8200) ainput, ninput, aword(2), aword(3), aword(4)
        write (iout, 8200) ainput, ninput, aword(2), aword(3), aword(4)
        go to 999
      endif

c.... Find the angle to be bisected.

c.... Find the bisector of the angle, its components, length, and endpoint.

      call aptbang (x(n1), y(n1), z(n1), x(n2), y(n2), z(n2),
     &              x(n3), y(n3), z(n3), 1, tol,
     &              dx, dy, dz, px, py, pz, nerra)

      call aptvunb (dx, dy, dz, 1, tol, ux, uy, uz, vlength, nerra)

 8210 format ('Intercept    (xyz)',1p3e20.12 /   
     &        'Vector dx, dy, dz ',1p3e20.12 /
     &        '  Length          ',1pe20.12 )

      write (   6, 8210) px, py, pz, dx, dy, dz, vlength
      write (iout, 8210) px, py, pz, dx, dy, dz, vlength

  999 return

c.... End of subroutine bisectx.      (+1 line)
      end
