      subroutine clfind (nw, ncl)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  clfind   Updated     1997 May 6 17:00.
c               clfind   Originated  1997 May 6 17:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find a cluster with the same name as an ASCII argument,
c               or the value of an ASCII variable argument,
c               display the cluster, or display an error message.
c
c     Logic:    Entry points:  clfind.
c clfind        called by:  accel.
c
c clfind        Calls:  clout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     aword(nw) Input    Name of cluster to find.
c
c     ncl       Output   Index of cluster.
c
c     nw        Input    Index of argument to test.     
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

 8110 format ('  clfind ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Argument number is bad:  ',i5)

      if ((nw .lt. 1)      .or.
     &    (nw .gt. nword)) then
        write (   6, 8110) ainput, ninput, nw
        write (iout, 8110) ainput, ninput, nw
        go to 999
      endif

      np = 0

      do 120 n = 1, nclusts           ! Loop over clusters.
        if (aword(nw) .eq. aclust(n)) then
          ncl = n
          call clout (ncl, ncl, 'min')
          go to 999
        endif
  120 continue                        ! End of loop over clusters.

 8120 format ('  clfind ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Named cluster does not exist:  ',a)

      write (   6, 8120) ainput, ninput, aword(nw)
      write (iout, 8120) ainput, ninput, aword(nw)

  999 return

c.... End of subroutine clfind.       (+1 line)
      end
