      subroutine geomend (atermess)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  geomend  Updated     2007 Januray 16 13:30.
c               geomend  Originated  1993 October 27 14:00.
c
c     Author:   Arthur L. Edwards
c
c     Purpose:  To end the run with a termination message.
c
c     Logic:    Entry point:  geomend.
c geomend       Called by:  closey, getio, getlun, main, openx.
c
c geomend       Calls:  closey, getlun, openx, tbank.
c
c     Biblio:
c
c     Glossary:
c
c     atermess  Input    Termination message.  Argument.
c
c     iout      acome    IOC for ASCII output file.
c
c     ksecr     acomm    Total run time, milliseconds.
c
c     History:
c
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*80 atermess           ! Termination message.

 8030 format (10a8)
 8040 format ('  GEOM time used, milliseconds =',i9,'.')

      call tbank (ksecr)

      write (   6, 8040) ksecr
      write (iout, 8040) ksecr

c.... Write the termination message.

 8050 format (/ 2x,a / '  GEOM all done.')
      write (   6, 8050) atermess
      if (iout .eq. 3) then
        write (iout, 8050) atermess
      endif

      stop

c.... End of subroutine geomend       (+ 1 line).
      end
