      subroutine hex

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  hex:     Updated     2004 November 23 13:30.
c               hex:     Originated  2001 September 4 17:30.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the hexidecimal form for a decimal number,
c               and vice versa, and the hexadecimal machine word form.
c
c     Logic:    Entry points:  hex
c hex           Called by:  helpall, main.
c
c hex           Calls:  apthexa, apthexd, varfind.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*24 awordh
      character*80 awordx
      character*8  ahex(10)
      equivalence (ahex, awordx)

c=======================================================================********

c.... Input line:  hex [help]

 8110 format ('  Command "hex":  acceptable input lines',
     &  ' include:' //
     &  '  "hex [help]"  Display this message.' //
     &  '  "hex in  STRING1 STRING2 STRING3 ..."' /
     &  '     Display any decimal floating point values for the' /
     &  '     hexadecimal integer or hexadecimal floating point' /
     &  '     values STRING1, STRING2, STRING3, ..., and their' /
     &  '     hexadecimal machine word formats.' //
     &  '  "hex out STRING1 STRING2 STRING3 ..."' /
     &  '     Display any decimal integer, decimal floating point' /
     &  '     and hexadecimal floating point values for the' /
     &  '     character strings, decimal values or variables STRING1,' /
     &  '     STRING2, STRING3, ..., and their hexadecimal' /
     &  '     machine word formats. ' //
     &  '  Synonyms:  [help, h].' )

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
        go to 999
      endif

c=======================================================================********

c.... Check for error.

 8120 format ('  hex ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Not 3 or more  words on "hex" line:  ', i3)

      if (nword .le. 2) then
        write (   6, 8120) ainput, ninput, nword
        write (iout, 8120) ainput, ninput, nword
        go to 999
      endif

c=======================================================================********

c.... Input line:  hex in STRING1 STRING2 STRING3 ...

      if (aword(2) .eq. 'in') then

c.... Display the decimal form for each hexadecimal string.

      idmaxx = 0.83 * idmax
      iemaxx = 0.83 * iemax

      do 510 nw = 3, nword

        awordx = aword(nw)

        write (   6, 8125)
        write (iout, 8125)

c....   Count and display non-blank groups of 8 characters (at least 1).

        ntot = 1
        do 410 n = 1, 10
          if (ahex(n) .ne. '') then
            ntot = n
          endif
  410   continue

        do 420 n = 1, ntot
          write (   6, 8130) ahex(n), ahex(n)
          write (iout, 8130) ahex(n), ahex(n)
  420   continue

c....   Display the hexadecimal machine word for any integer form of string.

        call apthexd (aword(nw), 1, 80, iamax, idmaxx, iemaxx,
     &                awordx, iwordx, fwordx, mtypex, nerra)

 8160   format ('  hex ERROR.  Reading ',a40,' line ',i5,'.' /
     &          '  Character string is not hexadecimal:' / a)
 8155   format ('  real    (mach, dec R) ',z16,3x,1pe22.14 /
     &          '  real    (mach, hex R) ',z16,4x,a)

        if ((mtypex .le. 1) .or. (nerra .ne. 0)) then
          write (   6, 8160) ainput, ninput, awordx
          write (iout, 8160) ainput, ninput, awordx
          go to 510
        endif

        if (mtypex .eq. 2) then
          write (   6, 8140) iwordx, iwordx
          write (iout, 8140) iwordx, iwordx
          write (   6, 8155) fwordx, fwordx, fwordx, awordx
          write (iout, 8155) fwordx, fwordx, fwordx, awordx
          go to 510
        endif

c....   Display the hexadecimal machine word for any real form of string.

        if (mtypex .eq. 3) then
          write (   6, 8155) fwordx, fwordx, fwordx, awordx
          write (iout, 8155) fwordx, fwordx, fwordx, awordx
        endif

  510 continue

      go to 999

      endif

c=======================================================================********

c.... Input line:  hex out STRING1 STRING2 STRING3 ...

      if (aword(2) .eq. 'out') then

c.... Display the hexadecimal machine words for each string.

 8125 format ('')
 8130 format ('  string  (mach, ASCII) ',z16,4x,'"',a,'"')
 8140 format ('  integer (mach, dec I) ',z16,3x,i22)
 8150 format ('  real    (mach, dec R) ',z16,3x,1pe22.14 /
     &        '  real    (mach, hex R) ',z16,4x,a)

      do 310 nw = 3, nword

        awordx = aword(nw)

        write (   6, 8125)
        write (iout, 8125)

c....   Count and display non-blank groups of 8 characters (at least 1).

        ntot = 1
        do 210 n = 1, 10
          if (ahex(n) .ne. '') then
            ntot = n
          endif
  210   continue

        do 220 n = 1, ntot
          write (   6, 8130) ahex(n), ahex(n)
          write (iout, 8130) ahex(n), ahex(n)
  220   continue

        call varfind (nw, nw)

c....   Display the hexadecimal machine word for any integer form of string.

        if ((mtype(nw) .eq. 2) .or. (mtype(nw) .eq. 3)) then
          call apthexa (fword(nw), 24, awordh, nerra)
        endif

        if (mtype(nw) .eq. 2) then
          write (   6, 8140) iword(nw), iword(nw)
          write (iout, 8140) iword(nw), iword(nw)
          write (   6, 8150) fword(nw), fword(nw), fword(nw), awordh
          write (iout, 8150) fword(nw), fword(nw), fword(nw), awordh
          go to 310
        endif

c....   Display the hexadecimal machine word for any real form of string.

        if (mtype(nw) .eq. 3) then
          write (   6, 8150) fword(nw), fword(nw), fword(nw), awordh
          write (iout, 8150) fword(nw), fword(nw), fword(nw), awordh
        endif

  310 continue

      go to 999

      endif

c=======================================================================********

c.... Input line not recognized.

 8810 format ('  hex ERROR.  Reading ',a40,' line ',i5,'.' /
     &        '  Input line is not recognized.')

      write (   6, 8810) ainput, ninput
      write (iout, 8810) ainput, ninput

c=======================================================================********

  999 return

c.... End of subroutine hex.          (+1 line)
      end
