      subroutine input

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  input    Updated     2006 February 12 15:00.
c               input    Originated  1993 November 2 10:40.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display or specify the input medium (the user's terminal or
c               an input file), and if not the user's terminal, to specify the
c               first and last line to be read, and optionally, executed.
c
c     Logic:    Entry points:  input.
c input         Called by:  .*, doenddo, helpall, main, return*, undo.
c
c input         Calls:  aptchap, aptchmv, aptffip, openx, varfind.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Local variables.

cdel      common /ccinput/ acmdlast       ! The last 8 characters of acmd.
cdel      character*8      acmdlast       ! The last 8 characters of acmd.
      common /ccinput/ aname          ! A file name.
      character*80     aname          ! A file name.
      common /ccinput/ atype          ! A file type, 'text'.
      character*8      atype          ! A file type, 'text'.

      character*8      alast          ! The last 8 characters of achar.
      equivalence (alast, achar(73))

c=======================================================================********
cbugc***DEBUG begins.
cbug 9131 format ('input DEBUG.  nbug =',i3,'.')
cbug      nbug = 1
cbug      write (   6, 9131) nbug
cbug      write (iout, 9131) nbug
cbug      write (   6, 9132) (nw, aword(nw), iword(nw), fword(nw),
cbug     &                    mtype(nw), lword(nw), nw = 1, nword)
cbug      write (iout, 9132) (nw, aword(nw), iword(nw), fword(nw),
cbug     &                    mtype(nw), lword(nw), nw = 1, nword)
cbugc***DEBUG ends.

c.... Initialize.

 8100 format ('input (new) ',a40 /
     &        '  from line',i8,' or ',a40 /
     &        '  to   line',i8,' or ',a40 )
 8101 format ('input (old) ',a40 )
 8107 format ('  from line',i8,' or ',a40 )
 8102 format ('  to   line',i8,' or ',a40 )
 8103 format ('input (new) ',a40 )

      if (nword .eq. 0) then

        iin             = 5

        nflast          = 1
        nfiles          = 1
        ainfile(nfiles) = 'tty'
        ainput          = ainfile(nfiles)
cbugc***DEBUG begins.
cbug      nbug = 1
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
        ainfbeg(nfiles) = 'unspecified line'
        ainfend(nfiles) = 'end-of-file'
        infbeg(nfiles)  = 1
        infend(nfiles)  = 9999999
        ninput          = 0
        inline(nfiles)  = ninput
        incycle(nfiles) = 0

        go to 999

      endif                           ! nword = 0.

c=======================================================================********

c.... Input line:  goto

      if ((nword .eq. 1) .and.
     &    (aword(1) .eq. 'goto')) then
        nword = 2
        aword(2) = 'help'
      endif

c=======================================================================********

c.... Input line:  .
c.... Input line:  . help

 8118 format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Too many words on "." command line:  ',i3)
 8105 format (/ '  Command ".":  acceptable input lines include:' /
     &  '  ". help"         Display this message.' /
     &  '  "."              Repeat preceding command.' //
     &  '  Synonyms:  [help, h].' )

      if (aword(1) .eq. '.') then
        if (nword .eq. 1) then
          nword    = 3
          mtype(1) = 1
          aword(1) = 'input'
          mtype(2) = 1
          aword(2) = 'command'
          mtype(3) = 2
          aword(3) = '-1'
          iword(3) = -1
        elseif ((aword(2) .eq. 'help') .or.
     &          (aword(2) .eq. 'h'))   then
          write (   6, 8105)
          write (iout, 8105)
          go to 999
        else
          write (   6, 8118) ainput, ninput, nword
          write (iout, 8118) ainput, ninput, nword
          go to 999
        endif
      endif

c=======================================================================********

c.... Input line:  input

c.... Answer query.

      if ((nword .eq. 1)           .and.
     &    (aword(1) .ne. 'trace')  .and.
     &    (aword(1) .ne. 'return') .and.
     &    (aword(1) .ne. 'rtn'))   then

        if (nfiles .eq. 1) then
          write (   6, 8103) ainput
          write (iout, 8103) ainput
        else
          write (   6, 8101) ainfile(nflast)
          write (iout, 8101) ainfile(nflast)
          if (ainfile(nflast) .ne. 'tty') then
            write (   6, 8107) infbeg(nflast), ainfbeg(nflast)
            write (iout, 8107) infbeg(nflast), ainfbeg(nflast)
            write (   6, 8102) infend(nflast), ainfend(nflast)
            write (iout, 8102) infend(nflast), ainfend(nflast)
            write (   6, 8100) ainput,
     &        infbeg(nfiles), ainfbeg(nfiles),
     &        infend(nfiles), ainfend(nfiles)
            write (iout, 8100) ainput,
     &        infbeg(nfiles), ainfbeg(nfiles),
     &        infend(nfiles), ainfend(nfiles)
          else
            write (   6, 8103) ainput
            write (iout, 8103) ainput
          endif
        endif

        go to 999

      endif

c=======================================================================********

c.... Input line:  input help

 8108 format ('Input file (line',i8,'):  ',a)
 8110 format (/ '  Command "input":  acceptable input lines include:' /
     &  '  "goto help"     Display this message.' /
     &  '  "input help"    Display this message.' /
     &  '  "trace help"    Display this message.' /
     &  '  "return help"   Display this message.' /
     &  '  "input"         Display the current input medium.' /
     &  '  "trace"         Display the current return path.' //
     &  '  "return"        Read the preceding input medium,' /
     &  '     after the last line already read in.' /
     &  '  "input #"       Read the preceding input medium,' /
     &  '     after the last line already read in.' //
     &  '  "input tty"     Read your terminal.' //
     &  '  "input [IN_FILE, command] [?]"' /
     &  '     Read the file IN_FILE or the saved input lines,' /
     &  '     from beginning to end [and display only].' )

 8112 format (/
     &  '  "goto [LINE1,STRING1]"' /
     &  '     Read the current input file from line LINE1',
     &  ' (an integer), or from the' /
     &  '     first line beginning with the space-delimited string',
     &  ' STRING1, to the end.' //
     &  '  "input [IN_FILE,command] [LINE1,STRING1]',
     &  ' [LINE2,STRING2|LINE1,STRING1] [?]"' /
     &  '     Read file IN_FILE, or the saved input lines,' /
     &  '     from line LINE1 (an integer), or from the first line' /
     &  '     beginning with the space-delimited string STRING1,' /
     &  '     to line LINE2 (an integer), or to the first line' /
     &  '     beginning with the space-delimited string STRING2',
     &  ' [and display only].' /
     &  '     Use IN_FILE = conv.mac for metric conversion factors.' )

 8114 format (/
     &  '  Note:  use of "%" instead of IN_FILE means the current',
     &  ' input file.' //
     &  '  Note:  use of "$" instead of LINE1 or LINE2 means the last',
     &  ' saved input line,' /
     &  '    or the end-of-file of an input file.' //
     &  '  Note:  use of a negative integer for LINE1 or LINE2,',
     &  ' with option "command"' /
     &  '    means the line preceding the last saved input line',
     &  ' by that many lines.' //
     &  '  Synonyms:  [command, cmd, c], [help, h],',
     &  ' [input, in, i, read, rd, r, call],' /
     &  '    [return, rtn].' )

      if ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))  then
        write (   6, 8108) ninput, ainput
        write (iout, 8108) ninput, ainput
        write (   6, 8110)
        write (iout, 8110)
        write (   6, 8112)
        write (iout, 8112)
        write (   6, 8114)
        write (iout, 8114)
        go to 999
      endif

c=======================================================================********

c.... Input line:  return

      if ((aword(1) .eq. 'return') .or.
     &    (aword(1) .eq. 'rtn'))   then

 8115   format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Too many words on "return" command line:  ',i3)

        if (nword .eq. 1) then
          nword = 2
          mtype(1) = 1
          aword(1) = 'input'
          mtype(2) = 1
          aword(2) = '#'
        else
          write (   6, 8115) ainput, ninput, nword
          write (iout, 8115) ainput, ninput, nword
          go to 135
        endif

      endif

c=======================================================================********

c.... Input line:  goto STRING

      if (aword(1) .eq. 'goto') then

 8116   format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Not two words on "goto" command line:  ',i3)
 8117   format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Can only use "goto" command line in an input file.')
 8119   format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Can not use "goto" command line in a do loop.')

        if (ainput .eq. 'tty') then
          write (   6, 8117) ainput, ninput
          write (iout, 8117) ainput, ninput
          go to 999
        endif
cbugc***DEBUG begins.
cbug 9771 format ('input DEBUG.  nloop =',i5)
cbug      write (   6, 9771) nloop
cbug      write (iout, 9771) nloop
cbugc***DEBUG ends.

        if (nloop .gt. 0) then
          write (   6, 8119) ainput, ninput
          write (iout, 8119) ainput, ninput
          go to 999
        endif

        if (nword .eq. 2) then
          nword    = 4
          mtype(4) = 1
          aword(4) = '$'
          mtype(3) = mtype(2)
          aword(3) = aword(2)
          iword(3) = iword(2)
          fword(3) = fword(2)
          lword(3) = lword(2)
          mtype(2) = 1
          aword(2) = ainput
          mtype(1) = 1
          aword(1) = 'input'
        else
          write (   6, 8116) ainput, ninput, nword
          write (iout, 8116) ainput, ninput, nword
          go to 999
        endif

      endif                           ! Input line "goto STRING".

c=======================================================================********

c.... Input line:  trace

      if (aword(1) .eq. 'trace') then

 8104 format ('input trace ',a40 /
     &        '  from line',i8,' or ',a40 /
     &        '  to   line',i8,' or ',a40 )

        do 100 n = 1, nfiles
          write (   6, 8104) ainfile(n),
     &      infbeg(n), ainfbeg(n),
     &      infend(n), ainfend(n)
          write (iout, 8104) ainfile(n),
     &      infbeg(n), ainfbeg(n),
     &      infend(n), ainfend(n)
  100   continue
        go to 999
      endif

c=======================================================================********

c.... Input line:  input tty

      if (aword(2) .ne. 'tty') go to 130

c.... Test input for validity.

 8120 format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Too many words on "input" command line:  ',i3)

      if (nword .gt. 2) then
cbugc***DEBUG begins.
cbug      nbug = 21
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
        write (   6, 8120) ainput, ninput, nword
        write (iout, 8120) ainput, ninput, nword
        go to 999
      endif

      if (aword(2) .eq. ainput) then  ! Input file name same as old one.
        write (   6, 8134) ainput, ninput, ainput
        write (iout, 8134) ainput, ninput, ainput
        go to 999
      endif

c.... Reassign the input medium to the user's terminal.

  120 iin             = 5

      inline(nfiles)  = ninput

      nflast          = nfiles
      nfiles          = nfiles + 1
      ainfile(nfiles) = 'tty'
      ainput          = ainfile(nfiles)
cbugc***DEBUG begins.
cbug      nbug = 2
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
      ainfbeg(nfiles) = 'unspecified line'
      ainfend(nfiles) = 'end-of-file'
      infbeg(nfiles)  = 1
      infend(nfiles)  = 9999999
      ninput          = ncmds
      inline(nfiles)  = ninput
      incycle(nfiles) = 0

cbugc***DEBUG begins.
cbug 9701 format ('input DEBUG.  Statement 120.')
cbug      write (   6, 9701)
cbug      write (iout, 9701)
cbugc***DEBUG ends.
      if (nfiles .gt. 1) then
        write (iout, 8101) ainfile(nflast)
        if (ainfile(nflast) .ne. 'tty') then
          write (   6, 8107) infbeg(nflast), ainfbeg(nflast)
          write (iout, 8107) infbeg(nflast), ainfbeg(nflast)
          write (   6, 8102) infend(nflast), ainfend(nflast)
          write (iout, 8102) infend(nflast), ainfend(nflast)
        endif
      endif

      write (   6, 8103) ainput
      write (iout, 8103) ainput

      go to 300

  130 continue                        ! Input line was not:  input tty

c=======================================================================********

c.... Input line:  input #

      if  (aword(2) .ne. '#') go to 145

c.... Test input line for validity.

      if (nword .gt. 2) then
cbugc***DEBUG begins.
cbug      nbug = 22
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
        write (   6, 8120) ainput, ninput, nword
        write (iout, 8120) ainput, ninput, nword
        if (ainput .eq. 'tty') go to 999
        go to 120
      endif

 8122 format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  There is no previous input file.')

  135 if (nfiles .eq. 1) then
        write (   6, 8122) ainput, ninput
        write (iout, 8122) ainput, ninput
        if (ainput .eq. 'tty') go to 999
        go to 120
      endif

c.... Assign the input medium to the previously open file.

  138 nflast          = nfiles
      nfiles          = nfiles - 1
cbugc***DEBUG begins.
cbug      nbug = 3
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
c*************************************************************
      if (ainfile(nfiles) .eq. ainput) go to 138
c*************************************************************
      ainput          = ainfile(nfiles)
cbugc***DEBUG begins.
cbug      nbug = 4
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
      ainfbeg(nfiles) = 'unspecified line'
      infbeg(nfiles)  = inline(nfiles) + 1 

      if (infbeg(nfiles) .gt. infend(nfiles)) go to 135

      if (ainput .eq. 'tty') then

        iin             = 5
  
        ainfend(nfiles) = 'end-of-file'
        infbeg(nfiles)  = 1
        infend(nfiles)  = 9999999
        ninput          = ncmds
        inline(nfiles)  = ninput
  
        if (nfiles .gt. 1) then
          write (iout, 8101) ainfile(nflast)
          if (ainfile(nflast) .ne. 'tty') then
            write (   6, 8107) infbeg(nflast), ainfbeg(nflast)
            write (iout, 8107) infbeg(nflast), ainfbeg(nflast)
            write (   6, 8102) infend(nflast), ainfend(nflast)
            write (iout, 8102) infend(nflast), ainfend(nflast)
          endif
        endif
  
        write (   6, 8103) ainput
        write (iout, 8103) ainput

        go to 300

      endif

c.... Position the new input medium.

      if (ainput .ne. 'command') then ! Last input medium was a file.

        iin      = 2

        close (2)

        atype = 'text'
        isize = 0
        call openx (2, ainput, atype, -1, isize)

 8130   format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Input file does not exist:  ',a)

        if (isize .eq. -1) then
cbugc***DEBUG begins.
cbug      nbug = 5
cbug 9130 format ('input DEBUG.  nbug = ',i3,'  ainput = ',a,
cbug     &  '  nfiles = ',i3)
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
          write (   6, 8130) ainput, ninput, ainput
          write (iout, 8130) ainput, ninput, ainput
          go to 135
        endif

c....   Position the new file at line infbeg(nfiles).

        ninput  = 0

        do 140 n = 2, infbeg(nfiles)

          call aptffip (iin, afd, iamax, idmax, iemax, aword, iword,
     &                  fword, mtype, lword, nword, achar, nerr)
cbugc***DEBUG begins.
cbug 9101 format ('nbug=',i5,'  iin='i3)
cbug      nbug = 201
cbug      write (   6, 9101) nbug, iin
cbug      write (iout, 9101) nbug, iin
cbugc***DEBUG ends.
cbugc***DEBUG begins.
cbug 9132 format (/ 'input DEBUG.' / 'nw =',i3 / 'aword = ',a /
cbug     &        'iword =',i8 / 'fword =',1pe20.12 / 'mtype =',i2 /
cbug     &        'lword =',i3 )
cbug      nbug = 2
cbug      write (   6, 9131) nbug
cbug      write (iout, 9131) nbug
cbug      write (   6, 9132) (nw, aword(nw), iword(nw), fword(nw),
cbug     &                    mtype(nw), lword(nw), nw = 1, nword)
cbug      write (iout, 9132) (nw, aword(nw), iword(nw), fword(nw),
cbug     &                    mtype(nw), lword(nw), nw = 1, nword)
cbugc***DEBUG ends.

          ninput  = ninput + 1

 8140    format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &     '  Reached end-of-file.')

          if (nerr .eq. -1) then      ! Reached end-of-file in input file.
            write (   6, 8140) ainput, ninput
            write (iout, 8140) ainput, ninput
            nword    = 2
            mtype(1) = 1
            aword(1) = 'input'
            mtype(2) = 1
            aword(2) = '#'
            go to 135
          endif

  140   continue

cbugc***DEBUG begins.
cbug 9702 format ('input DEBUG.  Statement 140.')
cbug      write (   6, 9702)
cbug      write (iout, 9702)
cbugc***DEBUG ends.

        go to 200

      else                            ! Last input was saved input lines.

        iin    = 5
        ninput = infbeg(nfiles) - 1

        go to 300

      endif                           ! Tested last input medium.

  145 continue

c=======================================================================********

c.... Input line:  input ...

c.... See if input file is command file.

      if ((aword(2) .eq. 'command') .or.
     &    (aword(2) .eq. 'cmd')     .or.
     &    (aword(2) .eq. 'c'))      then
        aword(2) = afilcmd                             ! NEW.
      endif

c.... Find first and last line limits.

      if ((nword .gt. 4)       .and.
     &    (aword(nword) .ne. '?')) then
cbugc***DEBUG begins.
cbug      nbug = 23
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
        write (   6, 8120) ainput, ninput, nword
        write (iout, 8120) ainput, ninput, nword
        go to 999
      endif

c.... Test for '?' at end of input line.

      kedit = 0
      if ((nword .ge. 3)          .and.
     &    (aword(nword) .eq. '?')) then
        kedit = 1
        nword = nword - 1
      endif

c.... Find the number or string of the first and last line to read.

      inline(nfiles)  = ninput

      nflast          = nfiles
      if (aword(2) .ne. ainfile(nfiles)) then
c?????Do next line only if new file name different from old file name!
        nfiles = nfiles + 1
      endif
cbugc***DEBUG begins.
cbug      nbug = 6
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.

      if (nword .eq. 2) then          ! Read the entire file.
        ainfbeg(nfiles) = 'unspecified line'
        ainfend(nfiles) = 'end-of-file'
        infbeg(nfiles)  = 1
        infend(nfiles)  = 9999999
        if (aword(2) .eq. afilcmd) infend(nfiles) = ncmds
        go to 150
      endif

c.... Find the line number equivalent of the input character "$",
c....   and negative offsets.

      if (aword(2) .eq. afilcmd) then
        indollar = ncmds
      else
        indollar = 9999999
      endif

      if (aword(3) .eq. '$') then
        mtype(3) = 2
        iword(3) = indollar
      endif

      if ((mtype(3) .eq. 2)  .and.
     &    (iword(3) .lt. 0)) then
        iword(3) = indollar + iword(3)
      endif

      if (aword(4) .eq. '$') then
        mtype(4) = 2
        iword(4) = indollar
      endif

      if ((mtype(4) .eq. 2)  .and.
     &    (iword(4) .lt. 0)) then
        iword(4) = indollar + iword(4)
      endif

c.... Make sure line numbers do not exceed current length of command file.

 8124 format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  First line number exceeds number of saved commands:  ',2i8)
 8126 format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Second line number exceeds number of saved commands:  ',2i8)

      if (aword(2) .eq. afilcmd) then
        if ((mtype(3) .eq. 2) .and.
     &      (iword(3) .gt. 0)) then
          if (iword(3) .gt. ncmds) then
            write (   6, 8124) ainput, ninput, iword(3), ncmds
            write (iout, 8124) ainput, ninput, iword(3), ncmds
            if (aword(2) .ne. ainfile(nfiles)) then
c?????Do next line only if new file name different from old file name!
              nfiles = nfiles - 1
            endif
            go to 120
          endif
        endif
        if ((mtype(4) .eq. 2) .and.
     &      (iword(4) .gt. 0)) then
          if (iword(4) .gt. ncmds) then
            write (   6, 8126) ainput, ninput, iword(4), ncmds
            write (iout, 8126) ainput, ninput, iword(4), ncmds
            if (aword(2) .ne. ainfile(nfiles)) then
c?????Do next line only if new file name different from old file name!
              nfiles = nfiles - 1
            endif
            go to 120
          endif
        endif
      endif

      call varfind (3, 3)

      if (mtype(3) .eq. 2) then       ! Find the first line number.
        ainfbeg(nfiles) = 'unspecified line'
        ainfend(nfiles) = 'end-of-file'
        infbeg(nfiles)  = iword(3)
        infend(nfiles)  = iword(3)
      else                            ! Find the first line string.
        ainfbeg(nfiles) = aword(3)
        ainfend(nfiles) = aword(3)
        infbeg(nfiles)  = 9999999
        infend(nfiles)  = 9999999
        if (aword(2) .eq. afilcmd) infend(nfiles) = ncmds
      endif

      if (nword .eq. 4) then

        call varfind (4, 4)

        if (mtype(4) .eq. 2) then     ! Find the last line number.
          ainfend(nfiles) = 'end-of-file'
          infend(nfiles)  = iword(4)
        else                          ! Find the last line word.
          ainfend(nfiles) = aword(4)
          infend(nfiles)  = 9999999
          if (aword(2) .eq. afilcmd) infend(nfiles) = ncmds
        endif
      endif

 8127 format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  First line number exceeds last line number:  ',2i8)

      if ((nword .eq. 4)               .and.
     &    (mtype(3) .eq. 2)            .and.
     &    (mtype(4) .eq. 2)            .and.
     &    (infend(nfiles) .lt. infbeg(nfiles))) then
        write (   6, 8127) ainput, ninput,
     &    infbeg(nfiles), infend(nfiles)
        write (iout, 8127) ainput, ninput,
     &    infbeg(nfiles), infend(nfiles)
        if (aword(2) .ne. ainfile(nfiles)) then
c?????Do next line only if new file name different from old file name!
          nfiles = nfiles + 1
        endif
cbugc***DEBUG begins.
cbug      nbug = 7
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
        go to 120
      endif

 8128 format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  First or last line number is not positive:  ',2i8)

      if ((infbeg(nfiles) .lt. 1)  .or.
     &    (infend(nfiles) .lt. 1)) then
        write (   6, 8128) ainput, ninput,
     &    infbeg(nfiles), infend(nfiles)
        write (iout, 8128) ainput, ninput,
     &    infbeg(nfiles), infend(nfiles)
        if (aword(2) .ne. ainfile(nfiles)) then
c?????Do next line only if new file name different from old file name!
          nfiles = nfiles + 1
        endif
cbugc***DEBUG begins.
cbug      nbug = 8
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
        go to 120
      endif

  150 continue
cbugc***DEBUG begins.
cbug 9705 format ('input DEBUG.  Old limits:' /
cbug     &  'infends=',i8,'  ainfends= ',a40)
cbug      if (nfiles .gt. 1) then
cbug        write (   6, 9705) infend(nflast), ainfend(nflast)
cbug        write (iout, 9705) infend(nflast), ainfend(nflast)
cbug      endif
cbug 9706 format ('input DEBUG.  New limits:' /
cbug     &  'infbeg =',i8,'  ainfbeg = ',a40 /
cbug     &  'infend =',i8,'  ainfend = ',a40 )
cbug        write (   6, 9706) infbeg(nfiles), ainfbeg(nfiles),
cbug     &    infend(nfiles), ainfend(nfiles)
cbug        write (iout, 9706) infbeg(nfiles), ainfbeg(nfiles),
cbug     &    infend(nfiles), ainfend(nfiles)
cbugc***DEBUG ends.

c=======================================================================********
cdel
cdelc.... Input line:  input command [?]
cdelc.... Input line:  input command LINE1 [LINE2|LINE1] [?]
cdelc.... Input line:  input command LINE1 STRING2 [?]
cdelc.... Input line:  input command STRING1 LINE2 [?]
cdelc.... Input line:  input command STRING1 [STRING2|STRING1] [?]
cdel
cdel      if ((aword(2) .eq. 'command') .or.
cdel     &    (aword(2) .eq. 'cmd')     .or.
cdel     &    (aword(2) .eq. 'c'))      then
cdel
cdel        aword(2) = afilcmd
cdel        iin             = 5
cdelc***DEBUG begins.
cdel      nbug = 202
cdel      write (   6, 9101) nbug, iin
cdel      write (iout, 9101) nbug, iin
cdelc***DEBUG ends.
cdel
cdel 8150   format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
cdel     &    '  First line number',i8,' is below lowest line saved:',i8)
cdel
cdel        nmodmin = max (1, ncmds - ncmdm)
cdel
cdel        if (nword .eq. 2) then
cdel          infbeg(nfiles) = nmodmin
cdel        endif
cdel
cdel        if ((mtype(3) .eq. 2)              .and.
cdel     &      (infbeg(nfiles) .lt. nmodmin)) then
cdel          write (   6, 8150) ainput, ninput, infbeg(nfiles), nmodmin
cdel          write (iout, 8150) ainput, ninput, infbeg(nfiles), nmodmin
cdel          nfiles = nfiles - 1
cdelcbugc***DEBUG begins.
cdelcbug      nbug = 9
cdelcbug      write (   6, 9130) nbug, ainput, nfiles
cdelcbug      write (iout, 9130) nbug, ainput, nfiles
cdelcbugc***DEBUG ends.
cdel          go to 120
cdel        endif
cdel
cdel        ninput          = infbeg(nfiles) - 1
cdel
cdel        if (afilcmd .eq. 'geom.cmd') then
cdel          ainfile(nfiles) = 'geom.cmd'              ! NEW.  Was 'command'.
cdel        else
cdel          ainfile(nfiles) = 'afilcmd'               ! NEW.  Was 'command'.
cdel        endif
cdel        ainput          = ainfile(nfiles)
cdelcbugc***DEBUG begins.
cdelcbug      nbug = 10
cdelcbug      write (   6, 9130) nbug, ainput, nfiles
cdelcbug      write (iout, 9130) nbug, ainput, nfiles
cdelcbugc***DEBUG ends.
cdel        incycle(nfiles) = 0
cdel
cdel        if (infend(nfiles) .gt. ncmds) then
cdel          infend(nfiles) = ncmds
cdel        endif
cdel
cdel 8155   format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
cdel     &    '  First line number exceeds current size of list:',i8)
cdel
cdel        if ((mtype(3) .eq. 2)            .and.
cdel     &      (infbeg(nfiles) .gt. ncmds)) then
cdel          write (   6, 8155) ainput, ninput, ncmds
cdel          write (iout, 8155) ainput, ninput, ncmds
cdel          nfiles = nfiles - 1
cdelcbugc***DEBUG begins.
cdelcbug      nbug = 11
cdelcbug      write (   6, 9130) nbug, ainput, nfiles
cdelcbug      write (iout, 9130) nbug, ainput, nfiles
cdelcbugc***DEBUG ends.
cdel          go to 120
cdel        endif
cdel
cdel        if (kedit .eq. 1) then
cdelcbugc***DEBUG begins.
cdelcbug 9704 format ('input DEBUG.  Statement "command".')
cdelcbug      write (   6, 9704)
cdelcbug      write (iout, 9704)
cdelcbug      if (nfiles .gt. 1) then
cdelcbug        write (   6, 8101) ainfile(nflast)
cdelcbug        write (iout, 8101) ainfile(nflast)
cdelcbug        if (ainfile(nflast) .ne. 'tty') then
cdelcbug          write (   6, 8107) infbeg(nflast), ainfbeg(nflast)
cdelcbug          write (iout, 8107) infbeg(nflast), ainfbeg(nflast)
cdelcbug          write (   6, 8102) infend(nflast), ainfend(nflast)
cdelcbug          write (iout, 8102) infend(nflast), ainfend(nflast)
cdelcbug        endif
cdelcbug      endif
cdelcbug      write (   6, 8100) ainput,
cdelcbug     &  infbeg(nfiles), ainfbeg(nfiles),
cdelcbug     &  infend(nfiles), ainfend(nfiles)
cdelcbug      write (iout, 8100) ainput,
cdelcbug     &  infbeg(nfiles), ainfbeg(nfiles),
cdelcbug     &  infend(nfiles), ainfend(nfiles)
cdelcbugc***DEBUG ends.
cdel
cdel          kwrite = 0
cdel          nword  = 0
cdel
cdel          nmodmin = max (1, ncmds - ncmdm)
cdel
cdel          do 160 n = nmodmin, ncmds
cdel
cdel            nn = 1 + mod (n - 1, ncmdm)
cdel
cdel            call aptchap (acmd(1,nn), 1, ncharm, nwordm, afd,
cdel     &                    iamax, idmax, iemax, aword, iword, fword,
cdel     &                    mtype, lword, nword, nerr)
cdelc***DEBUG begins.
cdel      nbug = 203
cdel      write (   6, 9101) nbug, iin
cdel      write (iout, 9101) nbug, iin
cdelc***DEBUG ends.
cdel
cdel            if (n .ge. infbeg(nfiles)) kwrite = 1
cdel
cdel            if ((nword .gt. 0)         .and.
cdel     &          (aword(1) .eq. ainfbeg(nfiles)) .and.
cdel     &          (kwrite .eq. 0))                then
cdel              kwrite   = 1
cdel            endif
cdel
cdel            if (kwrite .eq. 1) then   ! Edit saved input lines.
cdel
cdel              write (   6, 8200) n, (acmd(i,nn), i = 1, 72)
cdel              write (iout, 8200) n, (acmd(i,nn), i = 1, 72)
cdel
cdel              acmdlast = ' '
cdel
cdel              call aptchmv (acmd(1,nn), 73, 8, acmdlast, 1, nerr)
cdel
cdel              if (acmdlast .ne. ' ') then
cdel                write (   6, 8165) acmdlast
cdel                write (iout, 8165) acmdlast
cdel              endif
cdel            endif
cdel
cdel            if (n .ge. infend(nfiles)) go to 135
cdel
cdel            if ((nword .gt. 0)                   .and.
cdel     &          (kwrite .eq. 1)                  .and.
cdel     &          (aword(1) .eq. ainfend(nfiles))) go to 135
cdel
cdel  160     continue
cdel
cdel          go to 135                   ! Reset input to previous medium.
cdel
cdel        else                          ! Execute saved input lines.
cdel
cdel          if (ainfbeg(nfiles) .ne. 'unspecified line') then
cdel
cdelc....       Find the first saved input line beginning with string
cdelc....         ainfbeg(nfiles).
cdel
cdel            ninput = 0
cdel
cdel            nmodmin = max (1, ncmds - ncmdm)
cdel
cdel            do 170 n = nmodmin, ncmds
cdel
cdel              nn = 1 + mod (n - 1, ncmdm)
cdel
cdel              call aptchap (acmd(1,nn), 1, ncharm, nwordm, afd,
cdel     &                      iamax, idmax, iemax, aword, iword, fword,
cdel     &                      mtype, lword, nword, nerr)
cdelc***DEBUG begins.
cdel      nbug = 204
cdel      write (   6, 9101) nbug, iin
cdel      write (iout, 9101) nbug, iin
cdelc***DEBUG ends.
cdel
cdel              if ((nword .gt. 0)                   .and.
cdel     &            (aword(1) .eq. ainfbeg(nfiles))) then
cdelcbugc***DEBUG begins.
cdelcbug 9707 format ('input DEBUG.  Found initial string in saved',
cdelcbug     &  ' input lines.' /
cdelcbug     &        'ainfbeg= ',a40 /
cdelcbug     &        'command number ninput=',i8)
cdelcbug      write (   6, 9707) ainfbeg(nfiles), ninput
cdelcbug      write (iout, 9707) ainfbeg(nfiles), ninput
cdelcbugc***DEBUG ends.
cdel                go to 200
cdel              endif
cdel
cdel              ninput  = ninput + 1
cdel
cdel  170       continue
cdel
cdelc....       Failed to find string.
cdel
cdel 8170       format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
cdel     &        '  Specified string does not exist:',a)
cdel
cdel            write (   6, 8170) ainput, ninput, ainfbeg(nfiles)
cdel            write (iout, 8170) ainput, ninput, ainfbeg(nfiles)
cdel            go to 135
cdel
cdel          endif                       ! Positioned file to read.
cdel
cdelcbugc***DEBUG begins.
cdelcbug 9777 format ('input DEBUG.  Statement 170.')
cdelcbug      write (   6, 9777)
cdelcbug      write (iout, 9777)
cdelcbugc***DEBUG ends.
cdel
cdel          go to 200
cdel
cdel        endif                         ! Tested kedit.
cdel
cdel      endif                           ! Input line:  input command ...
cdel
c=======================================================================********

c.... Input line:  input IN_FILE [?]
c.... Input line:  input IN_FILE $
c.... Input line:  input IN_FILE LINE1 [LINE2|LINE1] [?]
c.... Input line:  input IN_FILE LINE1 STRING2 [?]
c.... Input line:  input IN_FILE STRING1 LINE2 [?]
c.... Input line:  input IN_FILE STRING1 [STRING2|STRING1] [?]

 8132 format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Input file name same as current output file name:  ',a)

      if (aword(2) .eq. afilout) then  ! Input file name same as output file.
        write (   6, 8132) ainput, ninput, afilout
        write (iout, 8132) ainput, ninput, afilout
        go to 999
      endif

coldx      if (aword(2) .eq. afilcmd) then ! Input file same as command file.
coldx        if (infend(nfiles) .gt. ncmds) then
coldx          infend(nfiles) = ncmds
coldx        endif
coldx      endif
cold
cold 8133 format ('  input ERROR.  Reading ',a40,' line ',i5,'.' /
cold     &  '  Input file name same as current command file name:  ',a)
cold
cold      if (aword(2) .eq. afilcmd) then ! Input file same as command file.
cold        if (infend(nfiles) .gt. ncmds) then
cold          infend(nfiles) = ncmds
cold        endif
cold
cold        if (nword .eq. 2) then
cold        endif
cold        write (   6, 8133) ainput, ninput, afilcmd
cold        write (iout, 8133) ainput, ninput, afilcmd
cold        nfiles = nfiles - 1
coldcbugc***DEBUG begins.
coldcbug      nbug = 17
coldcbug      write (   6, 9130) nbug, ainput, nfiles
coldcbug      write (iout, 9130) nbug, ainput, nfiles
coldcbugc***DEBUG ends.
cold        go to 999
cold      endif

cbugc***DEBUG begins.
cbug 9301 format ('input DEBUG.  aword(2) = <',a,'>' /
cbug     &        '              ainput   = <',a,'>' )
cbug      write (   6, 9301) aword(2), ainput
cbug      write (iout, 9301) aword(2), ainput
cbugc***DEBUG ends.
      if (aword(2) .eq. '%') aword(2) = ainput
cbugc***DEBUG begins.
cbug      write (   6, 9301) aword(2), ainput
cbug      write (iout, 9301) aword(2), ainput
cbugc***DEBUG ends.

 8134 format ('  input WARNING.  Reading ',a40,' line ',i5,'.' /
     &  '  Input file name same as current input file name:  ',a)

      if (aword(2) .eq. ainput) then  ! Input file name same as current one.
        if (nloop .eq. 0) then
          write (   6, 8134) ainput, ninput, ainput
          write (iout, 8134) ainput, ninput, ainput
        endif
      endif

c.... Assign the input medium.

      close (2)

      aname = aword(2)
      atype = 'text'
      isize = 0
      call openx (2, aname, atype, -1, isize)

      if (isize .eq. -1) then
cbugc***DEBUG begins.
cbug      nbug = 12
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
        write (   6, 8130) ainput, ninput, aword(2)
        write (iout, 8130) ainput, ninput, aword(2)
        nfiles = nfiles - 1
cbugc***DEBUG begins.
cbug      nbug = 13
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
        go to 120
      endif

      iin             = 2
      ninput          = 0
      ainfile(nfiles) = aword(2)
      ainput          = ainfile(nfiles)
cbugc***DEBUG begins.
cbug      nbug = 14
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
      incycle(nfiles) = 0

c.... See if executing new file, or just reading it.

      if (kedit .eq. 0) then          ! Will read and execute new input medium.

c....   Position file at line infbeg(nfiles) or string ainfbeg(nfiles).

        if (infbeg(nfiles) .gt. 1) then        ! Position file.

          do 180 n = 2, infbeg(nfiles)

            ninput = ninput + 1

            call aptffip (iin, afd, iamax, idmax, iemax, aword, iword,
     &                    fword, mtype, lword, nword, achar, nerr)
cbugc***DEBUG begins.
cbug      nbug = 205
cbug      write (   6, 9101) nbug, iin
cbug      write (iout, 9101) nbug, iin
cbugc***DEBUG ends.
cbugc***DEBUG begins.
cbug      nbug = 3
cbug      write (   6, 9131) nbug
cbug      write (iout, 9131) nbug
cbug      write (   6, 9132) (nw, aword(nw), iword(nw), fword(nw),
cbug     &                    mtype(nw), lword(nw), nw = 1, nword)
cbug      write (iout, 9132) (nw, aword(nw), iword(nw), fword(nw),
cbug     &                    mtype(nw), lword(nw), nw = 1, nword)
cbugc***DEBUG ends.

            if (nerr .eq. -1) then    ! Reached end-of-file in input file.
              write (   6, 8140) ainput, ninput
              write (iout, 8140) ainput, ninput
              nword    = 2
              mtype(1) = 1
              aword(1) = 'input'
              mtype(2) = 1
              aword(2) = '#'
              go to 135
            endif

            if ((nword .gt. 0)                   .and.
     &          (aword(1) .eq. ainfbeg(nfiles))) then
              backspace iin
              ninput  = ninput - 1
cbugc***DEBUG begins.
cbug 9779 format ('input DEBUG.  Statement 180-.')
cbug      write (   6, 9779)
cbug      write (iout, 9779)
cbugc***DEBUG ends.
              go to 200
            endif

  180     continue

        endif                         ! Positioned file to read.

      else                            ! Editing only (kedit = 1).
cbugc***DEBUG begins.
cbug 9801 format ('input DEBUG 1.   kedit = ',i3)
cbug      write (   6, 9801) kedit
cbug      write (iout, 9801) kedit
cbug      write (   6, 8100) ainput,
cbug     &  infbeg(nfiles), ainfbeg(nfiles),
cbug     &  infend(nfiles), ainfend(nfiles)
cbug      write (iout, 8100) ainput,
cbug     &  infbeg(nfiles), ainfbeg(nfiles),
cbug     &  infend(nfiles), ainfend(nfiles)
cbugc***DEBUG ends.

        kwrite = 0
        nword  = 0

  190   continue
cbugc***DEBUG begins.
cbug 9802 format ('input DEBUG 2. ninput =',i4,
cbug     &  ' infend=',i8,' nword=',i4 /
cbug     &  '  aword(1)= ',a40 /
cbug     &  '  ainfend(nfiles)  = ',a40 )
cbug      write (   6, 9802) ninput, infend(nfiles),
cbug     &  nword, aword(1), ainfend(nfiles)
cbug      write (iout, 9802) ninput, infend(nfiles),
cbug     &  nword, aword(1), ainfend(nfiles)
cbugc***DEBUG ends.

        ninput = ninput + 1

        call aptffip (iin, afd, iamax, idmax, iemax, aword, iword,
     &                fword, mtype, lword, nword, achar, nerr)
cbugc***DEBUG begins.
cbug      nbug = 206
cbug      write (   6, 9101) nbug, iin
cbug      write (iout, 9101) nbug, iin
cbugc***DEBUG ends.
cbugc***DEBUG begins.
cbug      nbug = 4
cbug      write (   6, 9131) nbug
cbug      write (iout, 9131) nbug
cbug      write (   6, 9132) (nw, aword(nw), iword(nw), fword(nw),
cbug     &                    mtype(nw), lword(nw), nw = 1, nword)
cbug      write (iout, 9132) (nw, aword(nw), iword(nw), fword(nw),
cbug     &                    mtype(nw), lword(nw), nw = 1, nword)
cbugc***DEBUG ends.
cbugc***DEBUG begins.
cbug 9803 format ('input DEBUG 3. nerr =',i4)
cbug      write (   6, 9803) nerr
cbug      write (iout, 9803) nerr
cbugc***DEBUG ends.

        if (nerr .eq. -1) go to 135   ! Reached end-of-file in input file.

        if (ninput .ge. infbeg(nfiles)) kwrite = 1
cbugc***DEBUG begins.
cbug 9804 format ('input DEBUG 4.  ninput =',i4,' infbeg =',i8,
cbug     &  ' kwrite=',i2)
cbug      write (   6, 9804) ninput, infbeg(nfiles), kwrite
cbug      write (iout, 9804) ninput, infbeg(nfiles), kwrite
cbugc***DEBUG ends.

        if ((nword .gt. 0)                  .and.
     &      (aword(1) .eq. ainfbeg(nfiles)) .and.
     &      (kwrite .eq. 0))                then
          kwrite   = 1
        endif
cbugc***DEBUG begins.
cbug 9805 format ('input DEBUG 5. kwrite =',i2)
cbug      write (   6, 9805) kwrite
cbug      write (iout, 9805) kwrite
cbugc***DEBUG ends.

 8200   format (i5,3x,72a1)
 8165   format (8x,a)

        if (kwrite .eq. 1) then
          write (   6, 8200) ninput, (achar(i), i = 1, 72)
          write (iout, 8200) ninput, (achar(i), i = 1, 72)
          if (alast .ne. ' ') then
            write (   6, 8165) alast
            write (iout, 8165) alast
          endif
        endif

        if ((nword .gt. 0)                   .and.
     &      (kwrite .eq. 1)                  .and.
     &      (aword(1) .eq. ainfend(nfiles))) go to 135

        if (ninput .ge. infend(nfiles)) go to 135

        go to 190

      endif                           ! Tested kedit.
cbugc***DEBUG begins.
cbug 9778 format ('input DEBUG.  Statement 200-.')
cbug      write (   6, 9778)
cbug      write (iout, 9778)
cbugc***DEBUG ends.

c=======================================================================********

c.... Inform user of input medium and line number.

  200 if (nfiles .gt. 1) then
        write (   6, 8101) ainfile(nflast)
        write (iout, 8101) ainfile(nflast)
        if (ainfile(nflast) .ne. 'tty') then
          write (   6, 8107) infbeg(nflast), ainfbeg(nflast)
          write (iout, 8107) infbeg(nflast), ainfbeg(nflast)
          write (   6, 8102) infend(nflast), ainfend(nflast)
          write (iout, 8102) infend(nflast), ainfend(nflast)
        endif
      endif
cbugc***DEBUG begins.
cbug 9703 format ('input DEBUG.  Statement 200.')
cbug      write (   6, 9703)
cbug      write (iout, 9703)
cbugc***DEBUG ends.

      write (   6, 8100) ainput,
     &  infbeg(nfiles), ainfbeg(nfiles),
     &  infend(nfiles), ainfend(nfiles)
      write (iout, 8100) ainput,
     &  infbeg(nfiles), ainfbeg(nfiles),
     &  infend(nfiles), ainfend(nfiles)

  300 continue
cbugc***DEBUG begins.
cbug 9905 format (/ 'input DEBUG.  iin = ',i3)
cbug 9910 format (/ '  n =',i3,2x,a24,2x,a24,2x,a24 /
cbug     &          '  infbeg  =',i8,'  inline =',i8,' infend =',i8,
cbug     &          ' incycle =',i8 )
cbug
cbug      write (   6, 9905) iin
cbug      write (iout, 9905) iin
cbug
cbug      do 9010 n = 1, nfiles
cbug        write (   6, 9910) n, ainfile(n), ainfbeg(n), ainfend(n),
cbug     &                     infbeg(n), inline(n), infend(n), incycle(n)
cbug        write (iout, 9910) n, ainfile(n), ainfbeg(n), ainfend(n),
cbug     &                     infbeg(n), inline(n), infend(n), incycle(n)
cbug 9010 continue
cbugc***DEBUG ends.

c.... Remove any linkage cycles from end of input file array.

      if (nfiles .eq. 1) go to 999

      do 310 n = nfiles - 1, 1, -1
        if ((ainfile(n) .eq. ainfile(nfiles))  .and.
     &      (ainfbeg(n) .eq. ainfbeg(nfiles))  .and.
     &      (ainfend(n) .eq. ainfend(nfiles))  .and.
     &      ( infbeg(n) .eq.  infbeg(nfiles))  .and.
     &      ( infend(n) .eq.  infend(nfiles))) then
          incycle(nfiles) = nfiles - n
          go to 320
        endif
  310 continue

  320 if (incycle(nfiles) .eq. 0) then
        go to 999
      elseif (incycle(nfiles) .eq. 1) then
        nfiles = nfiles - 1
cbugc***DEBUG begins.
cbug      nbug = 15
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
      else
        do 330 n = nfiles - 1, nfiles - incycle(nfiles) + 1, -1
          if (incycle(n) .ne. incycle(nfiles)) go to 340
  330   continue
cbugc***DEBUG begins.
cbug 9915 format ('input DEBUG.  Removing ',i3,' input files.')
cbug      write (   6, 9915) incycle(nfiles)
cbug      write (iout, 9915) incycle(nfiles)
cbug      write (   6, 9905)
cbug      write (iout, 9905)
cbug
cbug      do 9020 n = 1, nfiles - incycle(nfiles)
cbug        write (   6, 9910) n, ainfile(n), ainfbeg(n), ainfend(n),
cbug     &                     infbeg(n), inline(n), infend(n), incycle(n)
cibug        write (iout, 9910) n, ainfile(n), ainfbeg(n), ainfend(n),
cbug     &                     infbeg(n), inline(n), infend(n), incycle(n)
cbug 9020 continue
cbugc***DEBUG ends.
        nfiles = nfiles - incycle(nfiles)
cbugc***DEBUG begins.
cbug      nbug = 16
cbug      write (   6, 9130) nbug, ainput, nfiles
cbug      write (iout, 9130) nbug, ainput, nfiles
cbugc***DEBUG ends.
  340   continue
      endif

  999 continue
cbugc***DEBUG begins.
cbug 9901 format ('input DEBUG.  Last line of input medium:' /
cbug     &        '  line     ',i8,' or "',a40,'"' )
cbug      write (   6, 9901) infend(nfiles), ainfend(nfiles)
cbug      write (iout, 9901) infend(nfiles), ainfend(nfiles)
cbugc***DEBUG ends.
      return

c.... End of subroutine input.        (+1 line)
      end
