      subroutine lout (n1, n2)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  lout     Updated     1995 June 13 15:15.
c               lout     Originated  1993 November 15 10:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the coordinates of the end points of lines n1 to n2.
c
c     Logic:    Entry points:  lout.
c lout          Called by:  cone, copy, delete, distance, line, linefind,
c               lstore, renamea, renamex, search, track, tristore.
c
c lout          Calls:  aptcsyv, aptvdis, pout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Initialize.

      nerr = 0

      nn1 = n1
      nn2 = n2
      if (nn1 .lt. 1) nn1 = 1
      if (nn2 .gt. nlines) nn2 = nlines

 8125 format ('line   ',a,' =   ',a,2x,a)
 8130 format ('coord  ',a,5x,a,4x,a,4x,a)
 8160 format ('  du,dv,dw  ',a6,1p3e20.12 /
     &        '  length',10x,1pe20.12)
 8110 format ('  lout ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  End point of line does not exist:  ',a)

      do 180 n = nn1, nn2

        if (aline(n) .eq. ' ') go to 180

        write (   6, 8125) aline(n), alipt1(n), alipt2(n)
        write (iout, 8125) aline(n), alipt1(n), alipt2(n)

        if (nn1 .eq. nn2) then           ! Print all data.

          write (   6, 8130) asys, acoordu, acoordv, acoordw
          write (iout, 8130) asys, acoordu, acoordv, acoordw

          do 110 np = 1, npoints
            if (apoint(np) .eq. alipt1(n)) then
              np1 = np
              call pout (np1, np1, 'min')
              go to 120
            endif
  110     continue
          nerr = 1
          write (   6, 8110) ainput, ninput, alipt1(n)
          write (iout, 8110) ainput, ninput, alipt1(n)

  120     do 130 np = 1, npoints
            if (apoint(np) .eq. alipt2(n)) then
              np2 = np
              call pout (np2, np2, 'min')
              go to 140
            endif
  130     continue
          nerr = 1
          write (   6, 8110) ainput, ninput, alipt2(n)
          write (iout, 8110) ainput, ninput, alipt2(n)

c....     Find the line components and length.

  140     if (nerr .ne. 0) go to 180

          call aptvdis (x(np1), y(np1), z(np1), x(np2), y(np2), z(np2),
     &                  1, tol, du, dv, dw, vlength, nerr)

          u  = x(np1)
          v  = y(np1)
          w  = z(np1)

c....     Convert units, if needed.
  
          if     (asys .eq. 'cyl') then
            call aptcsyv (0, 1, iunit, u, v, w, du, dv, dw, 1, tol,
     &                    nerr)
          elseif (asys .eq. 'sph') then
            call aptcsyv (0, 2, iunit, u, v, w, du, dv, dw, 1, tol,
     &                    nerr)
          endif

  
          write (   6, 8160) asys, du, dv, dw, vlength
          write (iout, 8160) asys, du, dv, dw, vlength
        endif

  180 continue

  999 return

c.... End of subroutine lout.         (+1 line)
      end
