      subroutine output

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  output   Updated     2004 November 23 13:30.
c               output   Originated  1994 July 18 13:40.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display or specify the output medium (a disk file).
c
c     Logic:    Entry points:  output.
c output        Called by:  helpall, main, write* .
c
c output        Calls:  aptffip, closey, openx.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Local variables.

      common /loutput/ aoutput        ! New output file name.
      character*80     aoutput        ! New output file name.
      common /loutput/ aoutputx       ! Old output file name.
      character*80     aoutputx       ! Old output file name.
      common /loutput/ anamex         ! Dummy input.
      character*8      anamex         ! Dummy input.

c=======================================================================********

c.... Input line:  output

c.... Answer query.

 8100 format ('  Current output file is          ',a /
     &        '  Current command summary file is ',a / '    line',i6)

      if (nword .eq. 1) then
        write (   6, 8100) afilout, afilcmd, ncmds
        write (iout, 8100) afilout, afilcmd, ncmds
        go to 999
      endif

c=======================================================================********

c.... Input line:  output help

 8110 format ('  Acceptable output lines include:' /
     &  '  "output help"      Display this message.' /
     &  '  "output"           Display the output file name.' //
     &  '  "output OUT_FILE"  Change the output file to OUT_FILE.' //
     &  '  Synonyms:  [help, h], [output, out, o, write, wr, w]' )

      if ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))  then
        write (   6, 8100) afilout, afilcmd, ncmds
        write (iout, 8100) afilout, afilcmd, ncmds
        write (   6, 8110)
        write (iout, 8110)
        go to 999
      endif

c=======================================================================********

c.... Input line:  output OUT_FILE

 8120 format ('  output ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  More than 2 words on input line:  ',i8)

      if (nword .gt. 2) then
        write (   6, 8120) ainput, ninput, nword
        write (iout, 8120) ainput, ninput, nword
        go to 999
      endif      

      aoutput = aword(2)

c.... See if the new output file name is the same as the old one.

 8132 format ('  output WARNING.  Reading ',a40,' line ',i5,'.' /
     &  '  Output file name same as current output file name:  ',a)
 8133 format ('  output WARNING.  Reading ',a40,' line ',i5,'.' /
     &  '  Output file name may not be tty.  Output always goes there.')

  160 if (aoutput .eq. afilout) then  ! Output file name same as old one.
        write (   6, 8132) ainput, ninput, aoutput
        write (iout, 8132) ainput, ninput, aoutput
        go to 999
      endif

c.... See if the new output file name is 'tty' (not allowed).

      if (aoutput .eq. 'tty') then    ! Output file name 'tty' not allowed.
        write (   6, 8133) ainput, ninput
        write (iout, 8133) ainput, ninput
        aoutput = afilout
        go to 160
      endif

c.... See if the new output file name is the same as the input file name.

 8130 format ('  output ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Output file name same as input file name:  ',a)

 8150   format ('  Type name of output file or "end" to use',
     &    ' current output file.')

 8340   format (/ '>',80a1)

 8140   format ('  output ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  More than 1 word on input line:  ',i3)

      if (aoutput .eq. ainput) then  ! Output file name same as input file name.
        write (   6, 8130) ainput, ninput, aoutput
        write (iout, 8130) ainput, ninput, aoutput
        go to 999
      endif

c.... See if the new output file name is the same as the command file name.

 8131 format ('  output ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Output file name same as command file name:  ',a)

cold  161 if (aoutput .eq. afilcmd) then
      if (aoutput .eq. afilcmd) then
        write (   6, 8131) ainput, ninput, aoutput
        write (iout, 8131) ainput, ninput, aoutput
        go to 999
      endif
cold
cold        if (ainput .ne. 'tty') go to 999
cold
cold  171   write (   6, 8150)
cold        write (iout, 8150)
cold
cold        call aptffip (5, afd, iamax, idmax, iemax, aword, iword, fword,
cold     &                mtype, lword, nword, achar, nerr)
cold
cold        if (achar(80) .eq. ' ') then
cold          write (iout, 8340) (achar(i), i = 1, 79)
cold        else
cold          write (iout, 8340) (achar(i), i = 1, 80)
cold        endif
cold
cold        write (icmd, 8343) (achar(i), i = 1, 79)
cold
cold        if (nword .ne. 1) then        ! Bad response.
cold          write (   6, 8140) ainput, ninput, nword
cold          write (iout, 8140) ainput, ninput, nword
cold          go to 171
cold        endif
cold
cold        aoutput = aword(1)
cold        if (aoutput .eq. 'end') go to 999
cold
cold        go to 161                     ! See if same as input file name.
cold
cold      endif                           ! Tested for file = input file name.

c.... See if the output file can be opened.  If so, ask permission to
c....   write over or append to.

      iadd  = 0                       ! Do not append to output file.
      ioutx = 23
      iopt  = -1                      ! Open, or return isize = -1.
  180 isize = 100000

      call openx (ioutx, aoutput, 'hardcopy', iopt, isize)

 8180 format ('  output WARNING.  Reading ',a40,' line ',i5,'.' /
     &  '  Output file already exists:  ',a )
 8182 format ('  Type "yes" to write over it, "add" to append',
     &  ' or "no" to cancel:  ',$)
 8185 format (80a1)

      if (iopt .eq. -1) then          ! See if file aoutput was opened.
        if (isize .eq. -1) then       ! File aoutput can not be opened.

          iopt = 0                    ! Create new file aoutput.
          go to 180

        else                          ! File aoutput already exists.

          write (   6, 8180) ainput, ninput, aoutput
          write (iout, 8180) ainput, ninput, aoutput

          if (ainput .ne. 'tty') then
            iadd = 1
            go to 200                 ! Append to existing output file.
          endif

          write (   6, 8182)
          write (iout, 8182)

          call aptffip (5, afd, iamax, idmax, iemax, aword, iword,
     &                  fword, mtype, lword, nword, achar, nerr)

          if (achar(80) .eq. ' ') then
            write (iout, 8340) (achar(i), i = 1, 79)
          else
            write (iout, 8340) (achar(i), i = 1, 80)
          endif

          if (nword .eq. 1) then
            if      (aword(1) .eq. 'yes') then
              iadd = 0
              go to 200               ! Write over existing output file.
            elseif ((aword(1) .eq. 'add') .or.
     &              (aword(1) .eq. 'a'))  then
              iadd = 1
              go to 200               ! Append to existing output file.
            endif
          endif

c....     Get another file name.

          call closey (ioutx, aoutput, 'hardcopy')

  190     write (   6, 8150)
          write (iout, 8150)

          call aptffip (5, afd, iamax, idmax, iemax, aword, iword,
     &                  fword, mtype, lword, nword, achar, nerr)

          if (achar(80) .eq. ' ') then
            write (iout, 8340) (achar(i), i = 1, 79)
          else
            write (iout, 8340) (achar(i), i = 1, 80)
          endif

          if (nword .ne. 1) then      ! Bad response.
            write (   6, 8140) nword
            write (iout, 8140) nword
            go to 190
          endif

          aoutput = aword(1)
          if (aoutput .eq. 'end') then
            write (   6, 8100) afilout, afilcmd, ncmds
            write (iout, 8100) afilout, afilcmd, ncmds
            go to 999
          endif

          go to 160                   ! See if same as input file name.

        endif                         ! Tested isize.
      endif                           ! Tested iopt.

c=======================================================================********

c.... Close the current output file.

 8200 format ('  Old     output file is          ',a )
 8210 format ('  New     output file is          ',a )

  200 write (iout, 8100) afilout, afilcmd, ncmds
      write (iout, 8210) aoutput

      call closey (ioutx, aoutput, 'hardcopy')

      call closey (iout, afilout, 'hardcopy')

      aoutputx = afilout
      afilout  = aoutput

c.... Open the new output file.

      iopt  = 0
      isize = 100000

      call openx (iout, afilout, 'hardcopy', iopt, isize)

 8212 format (a)

      if (iadd .eq. 1) then           ! Append to end of file.
  201   read  (unit=iout, fmt=8212, err=202, end=202) anamex
        go to 201
      endif
  202 continue

c.... Display the old and new output file names.

      write (   6, 8200) aoutputx
      write (iout, 8200) aoutputx
      write (   6, 8210) afilout
      write (iout, 8210) afilout

 8220 format ('  Version ',a24,'  Loaded on ',a10,' at ',a,' on ',a)

      write (iout, 8220) aversion, aloddate, alodtime, alodmach

 8230 format (/ '  GEOM run at ',2a12,2x,a)

      write (iout, 8230) adate, atime, amach

  999 return

c.... End of subroutine output.       (+1 line)
      end
