      subroutine ptfind (nw, np)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  ptfind   Updated     1994 September 2 17:00.
c               ptfind   Originated  1994 August 30 13:30.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find a point with the same name as an ASCII argument,
c               or the value of an ASCII variable argument,
c               display the point, or display an error message.
c
c     Logic:    Entry points:  ptfind.
c ptfind        Called by:  accel, arc, area, axisym, bisectx, circle,
c               cluster, cone, copy, cylinder, delete, disk, distance,
c               ellipsoid, hyperb, line, matrix, mesh, meshblk, movex, plane,
c               point, polygon, polyhed, project, prox, ptoper, quadric,
c               quoper, renamex, sphere, track, triangle, triple, twist,
c               vector, volume, voper, walk, where.
c
c ptfind        Calls:  pout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     aword(nw) Input    Name of point to find.
c
c     np        Output   Index of point.
c
c     nw        Input    Index of argument to test.     
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

 8110 format ('  ptfind ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Argument number is bad:  ',i5)

      if ((nw .lt. 1)      .or.
     &    (nw .gt. nword)) then
        write (   6, 8110) ainput, ninput, nw
        write (iout, 8110) ainput, ninput, nw
        go to 999
      endif

      np = 0

      do 120 n = 1, npoints           ! Loop over points.
        if (aword(nw) .eq. apoint(n)) then
          np = n
          call pout (np, np, 'min')
          go to 999
        endif
  120 continue                        ! End of loop over points.

      if (((aword(1) .eq. 'cluster') .or.
     &     (aword(1) .eq. 'cl'))     .and.
     &     (aword(nw) .eq. 'thru'))  then
        go to 999
      endif

 8120 format ('  ptfind ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Named point does not exist:  ',a)

      write (   6, 8120) ainput, ninput, aword(nw)
      write (iout, 8120) ainput, ninput, aword(nw)

  999 return

c.... End of subroutine ptfind.       (+1 line)
      end
