      subroutine symbdisp (n)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  symbdisp Updated     2002 August 27 15:50.
c               symbdisp Originated  2002 August 27 15:50.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display symbols and replacement values.
c
c     Logic:    Entry points:  symbdisp.
c symbdisp      Called by:  copy, delete, renamea, renamex, search, symbol,
c               variable.
c
c symbdisp      Calls:  symbout.

c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*80 awords             ! User message field.  ASCII (1).

c.... Initialize.

      awords = asymbl(n)

 8110 format ('  symbdisp ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  More than 10 consecutive symbol replacements are not',
     &  ' allowed.')

      nsub = 0                        ! Number of consecutive replacements.

  110 do 120 ns = 1, nsymbs           ! Loop over symbols.
        if (awords  .eq. asymbl(ns)) then

          nsub = nsub + 1             ! Number of consecutive replacements.

          if (nsub .gt. 10) then
            write (   6, 8110) ainput, ninput
            write (iout, 8110) ainput, ninput
            go to 999
          endif

          if (nsub .eq. 1) then       ! Write a blank line.
            write (   6, "('')")
            write (iout, "('')")
          endif

          call symbout (ns, ns)

          awords = asymbr(ns)

          go to 110

        endif
  120 continue                        ! End of loop over symbols.

  999 return

c.... End of subroutine symbdisp.     (+1 line)
      end
