      subroutine tetout (n1, n2, amount)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  tetout   Updated     1995 June 13 15:15.
c               tetout   Originated  1993 November 29 10:40.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the coordinates of the 4 points defining tetrahedrons
c               n1 to n2.
c
c     Logic:    Entry points:  tetout
c tetout        Called by:  cluster, copy, delete, distance, point, renamea,
c               renamex, search, tetra, where.
c
c tetout        Calls:  apttetd, pout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*8 amount              ! Amount of output to write.

c.... Initialize.

      nn1 = n1
      nn2 = n2
      if (nn1 .lt. 1) nn1 = 1
      if (nn2 .gt. ntets) nn2 = ntets

      do 190 n = nn1, nn2

        if (atetra(n) .eq. ' ') go to 190

 8102   format ('tetrahedron ',a,' = ',a,2x,a,2x,a,2x,a)

        write (   6, 8102) atetra(n), (atetpt(nv,n), nv = 1, 4)
        write (iout, 8102) atetra(n), (atetpt(nv,n), nv = 1, 4)

 8110   format ('  tetout ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Vertex point does not exist:  ',a)

        do 110 np = 1, npoints
          if (apoint(np) .eq. atetpt(1,n)) then
            np1  = np
            xtr1 = x(np)
            ytr1 = y(np)
            ztr1 = z(np)
            go to 120
          endif
  110   continue
        write (   6, 8110) ainput, ninput, atetpt(1,n)
        write (iout, 8110) ainput, ninput, atetpt(1,n)
        go to 190

  120   do 130 np = 1, npoints
          if (apoint(np) .eq. atetpt(2,n)) then
            np2  = np
            xtr2 = x(np)
            ytr2 = y(np)
            ztr2 = z(np)
            go to 140
          endif
  130   continue
        write (   6, 8110) ainput, ninput, atetpt(2,n)
        write (iout, 8110) ainput, ninput, atetpt(2,n)
        go to 190

  140   do 150 np = 1, npoints
          if (apoint(np) .eq. atetpt(3,n)) then
            np3  = np
            xtr3 = x(np)
            ytr3 = y(np)
            ztr3 = z(np)
            go to 160
          endif
  150   continue
        write (   6, 8110) ainput, ninput, atetpt(3,n)
        write (iout, 8110) ainput, ninput, atetpt(3,n)
        go to 190

  160   do 170 np = 1, npoints
          if (apoint(np) .eq. atetpt(4,n)) then
            np4  = np
            xtr4 = x(np)
            ytr4 = y(np)
            ztr4 = z(np)
            go to 180
          endif
  170   continue
        write (   6, 8110) ainput, ninput, atetpt(4,n)
        write (iout, 8110) ainput, ninput, atetpt(4,n)
        go to 190

 8188   format ('  tetout ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Points are coplanar.')

c....   Find the volume of the tetrahedron.

  180   call apttetd (xtr1, ytr1, ztr1, xtr2, ytr2, ztr2,
     &                xtr3, ytr3, ztr3, xtr4, ytr4, ztr4,
     &                1, tol, voltet(n), cenx, ceny, cenz, nerra)

 8185   format ('  Tetra volume    ',1p3e20.12 )

        write (   6, 8185) voltet(n)
        write (iout, 8185) voltet(n)

        if (voltet(n) .eq. 0.0) then
          write (   6, 8188) ainput, ninput
          write (iout, 8188) ainput, ninput
        endif

        if ((amount .eq. 'max')      .or.
     &      (amount .eq. 'maximum')) then

 8105     format ('coord  ',a,5x,a,4x,a,4x,a)

          write (   6, 8105) asys, acoordu, acoordv, acoordw
          write (iout, 8105) asys, acoordu, acoordv, acoordw

          call pout (np1, np1, 'min')
          call pout (np2, np2, 'min')
          call pout (np3, np3, 'min')
          call pout (np4, np4, 'min')

        endif

  190 continue

      return

c.... End of subroutine tetout.       (+1 line)
      end
